<?php
/*
Plugin Name: SGAR
Plugin URI:  http://sg-autorepondeur.com
Author: Matthieu Kischel
Version: 1.0
Author URI: http://sg-autorepondeur.com
*/

/* Add option page in admin menu */
function sgar_admin_menu() {
	global $sgar_options, $sgar_added_menu;
	$base = plugin_basename(__FILE__);

	if (!isset($sgar_options) or !$sgar_options)
		$sgar_options = get_option('sgar_options');

	add_menu_page('SGAR', 'SGAR', 'manage_options', 'sgar', 'display_sgar', plugins_url("images/sgar.png", __FILE__), 1001); 

	add_action('admin_init', 'sgar_init');
}

function display_sgar_header() {
    echo '
    <div class="wrap">
		<div class="icon32 icon32-bws" id="icon-options-general"></div>
		<h2>SG-Autorépondeur</h2>
		';
}

function display_sgar_footer() {
    echo '</div>';
}

function display_sgar() {
    display_sgar_header();
    sgar_settings_page();
    display_sgar_footer();
}

function sgar_init() {
	if (!session_id()) @session_start();
}


function sgar_settings() {
	global $sgar_options, $wpdb, $sgar_plugin_info;
	$sgar_db_version = "1.0";	

	/* Get options from the database */
	$sgar_options = get_option('sgar_options');
}

function sgar_activation() {
	sgar_settings();
}



/* Add settings page in admin area */
function sgar_settings_page() {
	global $sgar_options, $wpdb, $wp_version, $sgar_plugin_info;
	$error = $message = "";

	/* Save data for settings page */
	if (isset($_POST['sgar_form_submit']) && check_admin_referer(plugin_basename(__FILE__), 'sgar_nonce_name')) {
		
		$sgar_options['sg_membreid']					= stripcslashes(htmlspecialchars($_POST['sg_membreid']));
		$sgar_options['sg_codeactivationclient']		= stripcslashes(htmlspecialchars($_POST['sg_codeactivationclient']));
		$sgar_options['sg_listeid']					= stripcslashes(htmlspecialchars($_POST['sg_listeid']));
		        		
		update_option('sgar_options', $sgar_options, '', 'yes');            
		$message = "Modifications enregistrées";
	}
	?>
	
	<h3>Réglages</h3>
	<div class="updated fade" <?php if (!isset($_POST['sgar_form_submit']) || "" != $error) echo "style=\"display:none\""; ?>><p><strong><?php echo $message; ?></strong></p></div>
	<div class="error" <?php if ("" == $error) echo "style=\"display:none\""; ?>><p><strong><?php echo $error; ?></strong></p></div>
	
	<form id="sgar_settings_form" method="post" action="">
		
		<table class="form-table" style="width:auto;">
			<tr valign="top" class="sgar_additions_block">
				<th scope="row">SG Membre ID</th>
				<td colspan="2">
					<input type="text" name="sg_membreid" value="<?php echo $sgar_options['sg_membreid']; ?>" />
				</td>
			</tr>
			
			<tr valign="top" class="sgar_additions_block">
				<th scope="row">SG Code Activation Client</th>
				<td colspan="2">
					<input type="text" name="sg_codeactivationclient" value="<?php echo $sgar_options['sg_codeactivationclient']; ?>" />
				</td>
			</tr>
			
			<tr valign="top" class="sgar_additions_block">
				<th scope="row">SG Liste ID</th>
				<td colspan="2">
					<input type="text" name="sg_listeid" value="<?php echo $sgar_options['sg_listeid']; ?>" />
				</td>
			</tr>
		</table>    
		
		<input type="hidden" name="sgar_form_submit" value="submit" />
		<p class="submit">
			<input type="submit" class="button-primary" value="Valider" />
		</p>
		<?php wp_nonce_field(plugin_basename(__FILE__), 'sgar_nonce_name'); ?>
	</form>
	
	<?php	
}




/* After Subscription form function */
function sgar_after_check($user_id) {
    $user = get_user_by('id', $user_id);
    if ($user) {    	
    	$sgar_options = get_option('sgar_options');
    	if ($sgar_options['sg_listeid'] and $sgar_options['sg_membreid'] and $sgar_options['sg_codeactivationclient']) {
        	$email = $user->data->user_email;
        	$prenom = $user->data->display_name;
            require_once(dirname(__FILE__) . '/sg_api_v2.php');
    	}
	}
	return true;
}



/* After Check form function */
function sgar_send_mail_to_admin($message) {
	global $sgar_options, $wp_version, $wpdb;
	    
	$headers = '';
	$to = get_option("admin_email");   	
    if (!$to) return;
	
	$user_info_string = $userdomain = $form_action_url = '';
    
	if (strtolower(getenv('HTTPS')) == 'on')
		$form_action_url = 'https://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
	else
		$form_action_url = 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
    	
    	
	$subject = 'Erreur d\'inscription SG-Autorépondeur sur '.get_bloginfo('name');
    
    /* Message */
	$message_text = '<html>
	<head>
		<title>SG-Autorépondeur sur '.get_bloginfo('name').'</title>
	</head>
	<body>
	    <p><strong>Une erreur est survenue sur '.get_bloginfo('name').'</strong><br>
	    '.$message.'
	    <br><br>
		<table>';
			
	$userdomain = @gethostbyaddr($_SERVER['REMOTE_ADDR']);
	$user_info_string .= '<tr><td><br /></td><td><br /></td></tr>';
		
	$user_info_string .= '<tr><td>Adresse IP :</td><td>'.$_SERVER['REMOTE_ADDR']." (".$userdomain.")".'</td></tr>';
    $user_info_string .= '<tr><td>Date :</td><td>' . date_i18n(get_option('date_format') . ' ' . get_option('time_format'), strtotime(current_time('mysql'))) . '</td></tr>';
    $user_info_string .= '<tr><td>Page :</td><td>' . $form_action_url . '</td></tr>';
    $user_info_string .= '<tr><td>User Agent :</td><td>' . $user_agent . '</td></tr>';
    $message_text .= '<tr><td width="160">Message</td><td>'.$message.'</td></tr>';
	$message_text .= '
			<tr>
			    <td>Site</td>
			    <td>'. get_bloginfo("url").'</td>
			</tr>
			<tr>
				<td><br /></td>
				<td><br /></td>
			</tr>';
			
	$message_text_for_user = $message_text . '</table></body></html>';
	$message_text .= $user_info_string . '</table></body></html>';

	if (!function_exists('is_plugin_active'))
		require_once(ABSPATH . 'wp-admin/includes/plugin.php');
        
	$headers .= 'Content-type: text/html; charset=utf-8' . "\n";
	$headers .= 'From: ' . $to . '';
	$mail_result = wp_mail($to, $subject, $message_text, $headers);
	return $mail_result;

}


function sgar_plugin_action_links($links, $file) {
	static $this_plugin;
	if (!$this_plugin) $this_plugin = plugin_basename(__FILE__);

	if ($file == $this_plugin){
		$settings_link = '<a href="admin.php?page=sgar_form">Réglages</a>';
		array_unshift($links, $settings_link);
	}
	return $links;
}


function sgar_register_plugin_links($links, $file) {
	$base = plugin_basename(__FILE__);
	if ($file == $base) {
		$links[] = '<a href="admin.php?page=sgar_form">Réglages</a>';
	}
	return $links;
}


function sgar_admin_head() {
	if (isset($_REQUEST['page']) && ('sgar_form' == $_REQUEST['page'])) {
		global $wp_version;
		wp_enqueue_style('sgar_stylesheet', plugins_url('css/style.css', __FILE__));
	}
}

function sgar_wp_head() {
	wp_enqueue_style('sgar_stylesheet', plugins_url('css/style.css', __FILE__));
}


function sgar_delete_options() {
	delete_option('sgar_options');
	delete_site_option('sgar_options');
}

register_activation_hook(__FILE__, 'sgar_activation');

add_action('admin_menu', 'sgar_admin_menu');
add_action('init', 'sgar_init');

add_action('user_register', 'sgar_after_check');

/* Additional links on the plugin page */
add_filter('plugin_action_links', 'sgar_plugin_action_links', 10, 2);
add_filter('plugin_row_meta', 'sgar_register_plugin_links', 10, 2);

add_action('admin_enqueue_scripts', 'sgar_admin_head');
add_action('wp_enqueue_scripts', 'sgar_wp_head');

register_uninstall_hook(__FILE__, 'sgar_delete_options');
?>